use Jcode;

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
#	getHashedQueryFromArgument		CGI  -> AzzϊTu[`
#
#	AzzƂĕԂ܂
#
#	gp@F%Query = &getHashedQueryFromArgument( DestinationKanjiCode, bAcceptNULL ) ;
#	@FDestinationKanjiCode	ϊ抿R[h (sjis/euc/jis, ftHg͕ϊȂ)
#			OriginalKanjiCode		ϊOR[h (sjis/euc/jis, ftHg͎wȂ)
#			bAcceptNULL				"" ̋e (true/false, ftHg false)
#	߂lF$Query{'key'}		keyɑΉf[^
#								f[^ꍇA'\0'ŋ؂

sub getHashedQueryFromArgument
	{
	my( %hash ) = ( DestinationKanjiCode  => '',
					OriginalKanjiCode  => '',
					bAcceptNULL => false,
					@_ ) ;

	return &getHashedQuery(	sQuery=>&getArgument(),
							DestinationKanjiCode=>$hash{DestinationKanjiCode},
							OriginalKanjiCode=>$hash{OriginalKanjiCode},
							bAcceptNULL=>$hash{bAcceptNULL},
							@_ ) ;
	}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
#	getArgument				擾Tu[`
#
#	GET,POST\bhAR}h̋ʂȂ
#	fR[hꂽɕϊ܂
#
#	gp@F$strQuery = &getArgument( DestinationKanjiCode ) ;
#	@FDestinationKanjiCode	ϊ抿R[h (sjis/euc/jis, ftHg͕ϊȂ)
#			OriginalKanjiCode		ϊOR[h (sjis/euc/jis, ftHg͎wȂ)
#	߂lFMIMEfR[hꂽHTTP`
#			(key1=value1&key2=value2...)̈

sub getArgument
	{
	my( $strQuery ) ;

	if ( $ARGV[0] ne "" )
		{
		$strQuery = join( '&', @ARGV ) ;
		$strQuery =~ tr/ /+/;
		}
	elsif ( $strQuery eq "" )
		{
		read(STDIN, $strQuery, $ENV{'CONTENT_LENGTH'}) ;
		if ( $strQuery eq "" )
			{
			$strQuery = $ENV{'QUERY_STRING'} ;
			}
		}
	return $strQuery ;
	}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
#	getHashedQuery			Tu[`
#
#	MIMEfR[hꂽ̊evf𕪊A
#	AzzƂĕԂ܂
#
#	gp@F%Query = &getHashedQuery( sQuery, bAcceptNULL ) ;
#	@FsQuery				MIMEfR[hꂽHTTP`̈
#			bAcceptNULL			"" ̋e (true/false, ftHg false)
#	߂lF$Query{'key'}		keyɑΉf[^
#								f[^ꍇA'\0'ŋ؂

sub getHashedQuery
	{
	my( %hash ) = (	sQuery => '',
					DestinationKanjiCode  => '',
					OriginalKanjiCode  => '',
					bAcceptNULL => false,
					@_ ) ;

	my( @KeyValue, $strKey, $strValue, %hashQuery ) ;

	@KeyValue = split( /&/, $hash{sQuery} ) ;
	foreach (@KeyValue)
		{
		( $strKey, $strValue ) = split( /=/, $_ ) ;

		$strKey		= &decodeHttpString(	sQuery => $strKey,
											DestinationKanjiCode  => $hash{DestinationKanjiCode},
											OriginalKanjiCode  => $hash{OriginalKanjiCode} ) ;
		$strValue	= &decodeHttpString(	sQuery => $strValue,
											DestinationKanjiCode  => $hash{DestinationKanjiCode},
											OriginalKanjiCode  => $hash{OriginalKanjiCode} ) ;

		if( $hash{bAcceptNULL} eq true || ($hash{bAcceptNULL} eq false && $strValue ne "") )
			{
			$hashQuery{$strKey} = $hashQuery{$strKey} eq "" ? $strValue : $hashQuery{$strKey}."\0".$strValue ;
			}
		}
	return %hashQuery ;
	}


sub decodeHttpString
	{
	my( %hash ) = (	sQuery => '',
					DestinationKanjiCode  => '',
					OriginalKanjiCode  => '',
					@_ ) ;

	$hash{sQuery} =~ tr/+/ /;
	$hash{sQuery} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$hash{sQuery} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ( $hash{DestinationKanjiCode} ne '' )
		{
		if ( $hash{OriginalKanjiCode} ne '' )
			{
			Jcode::convert( \$hash{sQuery}, $hash{DestinationKanjiCode}, $hash{OriginalKanjiCode} ) ;
			}
		else
			{
			Jcode::convert( \$hash{sQuery}, $hash{DestinationKanjiCode} ) ;
			}
		}

	return $hash{sQuery} ;
	}
1 ;
